#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

/* global variable for maybe wrong header */
int headererror = 0;

/* Introduction Text */
void intro(void) {
	printf("\nQuake3Arena to RTCW Map Converter 0.4\t\t\tDec 2001");
	printf("\nCreated by [Win]Elchtest (elchtest@quake.de)");
	printf("\nCheck for Updates at: http://www.quake.de and http://www.winclan.de\n");
}

/* How to use it, if you use it wrong */
void hilfe(void) {
		printf("\n\nUse:\t\tbsp2rtcw [options] source target");
		printf("\nOptions are:\t-u Undo (RTCW converted map back to Q3A)");
		printf("\n\nExample:\tbsp2rtcw mymap.bsp mywolfmap.bsp");
		printf("\nExample:\tbsp2rtcw -u mywolfmap.bsp myquakemap.bsp");
}

/* look to the header if it's the right input file */
int valid(FILE *ein) {
	char header[5], decision[3];
	int i;
	
	for(i = 0; i < 4; i++) 
		header[i] = fgetc(ein);
	header[4] = '\0';

	/* checking for ASCII coded "IBSP" */
	if(strcmp(header, "IBSP")){
		printf("\nDoesn't look like a Quake/RTCW based input file.\n\n");
		headererror = 1;
		while(1) {
			printf("Do you want to continue? (y/n) ");
			fgets(decision, 3, stdin);
			printf("\n");
			switch(toupper(decision[0])) {
				case 'Y':
					rewind(ein);
					return 0;
				case 'N':
					exit(6);
			}
		}

	}
	rewind(ein);
	return 0;
}

/* everything went all right */
void success(void) {
	if (headererror != 0) 
		printf("\nChanges made, but maybe doesn't work (wrong input file).\n\n");
	else
		printf("\nSeems to be successfull!\n\n");
	printf("If you have trouble loading the map file:\n");
	printf("- run RTCW with paramaters: +sv_cheats 1\n");
	printf("- be sure to set in the console: \\sv_pure 0\n");
	printf("- load map in console with: \\devmap mymap");
}

/* start it with 3 or 4 parameters */
int main(int argc, char *argv[]) {
	FILE *ein, *aus;
	int ch, counter = 0, checked = 0, optionen = 0, undo = 0, korrekt = 0;

	intro();

	/* checking if parameters are ok */
	if(argc < 3 || argc > 4) {
		hilfe();
		exit(1);
	}

	if(argc == 4 && argv[1][0] != '-') {
		hilfe();
		exit(4);
	}

	/* setting undo and options flag */
	if (argc == 4 && argv[1][1] == 'u') {
		optionen = 1;
		undo = 1;
	}
		
		
	/* opening input and output file binary */
	if((ein=fopen(argv[1 + optionen],"rb"))==NULL) {
		printf("Error opening file!");
		exit(2);
	}
	if((aus=fopen(argv[2 + optionen],"wb"))==NULL) {
		printf("Error writing file!");
		exit(3);
	}
	
	/* checking if input file is valid */
	valid(ein);

	
	ch=fgetc(ein);
	
	while(!feof(ein)){
		if(counter == 4 && checked != 1) {
			korrekt = fputc(47 - undo,aus);
			if (korrekt < 0) {
				printf("Error during writing file at sensible part!");
				exit(5);
			}
			checked = 1;
		}
		else {
			korrekt = fputc(ch,aus);
			if (korrekt < 0) {
				printf("Error during writing file!");
				exit(4);
			}
		}
		ch = fgetc(ein);
		counter++;
	}
	
	fclose(ein);
	fclose(aus);

	success();
	printf("\n");
	return 0;
}

